Framework BRL.GLMax2D
Import BRL.Random
AppTitle = "4KBreakout"
SetGraphicsDriver(GLMax2DDriver())
Graphics 800,600,0,60
Function DL(a,b,c,d)
DrawLine a,b,c,d
EndFunction
Function SC(r,g,b)
SetColor r,g,b
EndFunction
Function SA(a#)
SetAlpha a
EndFunction
SetBlend(ALPHABLEND)
SC 200,200,200
DrawRect 0,0,80,30
SC 255,255,255
DL 0,0,80,0
DL 0,0,0,30
SC 50,50,50
DL 0,29,79,29
DL 79,0,79,29
Global imgBrick:TImage = LoadImage(GrabPixmap(0,0,80,30))
SC 255,255,255
DrawRect 0,0,800,600
SC 150,150,150
For i = 0 To 10
For j = 0 To 8
If j Mod 2 = i Mod 2 Then DrawRect 80*i,80*j,80,80
Next
Next
Function RectsOverlap(X1,Y1,b1,h1,X2,Y2,b2,h2)
If x1<=(x2+b2) And y1<=y2+h2 And (x1+b1) >=x2 And (y1+h1)>= y2 Then Return 1
End Function
Global imgBG:TImage = LoadImage(GrabPixmap(0,0,800,600))
MidHandleImage imgBG
Global bg:TBG = New TBG
Global bat:TBat = TBat.create()
Global ball:TBall = TBall.create()
SC 255,255,255
newbricks()
Function newbricks()
For i = 0 To 9
For j = 0 To 4+2*level
TBrick.list.addlast(TBrick.create(80*i,30*j))
Next
Next
EndFunction
Global level=1
Global score
Global lives=3
Repeat
Cls
rfx()
bg.u()
bg.d()
rfx()
For b:TBrick = EachIn TBrick.list
b.u()
If POI(imgBrick,b.x,b.y,ball.x+10,ball.y+20) Or POI(imgBrick,b.x,b.y,ball.x+10,ball.y) And b.hit = False Then 
ball.ys = -ball.ys
b.hit = True
b.x:+40
b.y:+15
score:+1
EndIf
If POI(imgBrick,b.x,b.y,ball.x,ball.y+10) Or POI(imgBrick,b.x,b.y,ball.x+20,ball.y+10) And b.hit = False Then 
ball.xs = -ball.xs
b.hit = True
b.x:+40
b.y:+15
score:+1
EndIf
Next
If TBrick.list.count() = 0 Then
level:+1
newbricks()
ball = TBall.create()
EndIf
rfx()
bat.u()
bat.d()
ball.u()
ball.d()
SC 0,0,0
SA 0.7
DrawRect 10,535,120,55
rfx()
DrawText "Score: "+score,20,545
DrawText "Level: "+level,20,555
DrawText "Lives: "+lives,20,565
If RectsOverlap(bat.x,bat.y,110,20,ball.x,ball.y,20,20) Then
ball.xs = ((ball.x+10)-(bat.x+55))/14
ball.ys = -ball.ys
EndIf
If ball.y>600 Then ball = TBall.create();lives:-1;If lives<0 Then Delay 3000;End
Flip
Until KeyHit(KEY_ESCAPE)
Function POI:Byte(image:TImage,x1,y1,x2,y2)
If x2 > x1 Then
If x2 < x1+ImageWidth(image) Then
If y2 > y1 Then
If y2 < y1+ImageHeight(image) Then Return True
EndIf
EndIf
EndIf
EndFunction
Function rfx()
SetRotation 0
SA 1
SetScale 1,1
SC 255,255,255
SetBlend(ALPHABLEND)
EndFunction
Type TBG
Field angle#
Method u()
angle:+0.1
EndMethod
Method d()
SC 150,150,255
SetScale 2,2
SetRotation angle
DrawImage imgBG,400,300
EndMethod
EndType
Type TBat
Field x#
Field y#
Function create:TBat()
Local b:TBat = New TBat
b.y = 580
b.x = 345
Return b
EndFunction
Method u()
If KeyDown(KEY_RIGHT) Then x:+7
If KeyDown(KEY_LEFT) Then x:-7
If x < 0 Then x = 0
If x > 690 Then x = 690
EndMethod
Method d()
DrawOval 0+x,0+y,20,20
DrawRect 10+x,0+y,90,20
DrawOval 90+x,0+y,20,20
EndMethod
EndType
Type TBall
Field x#
Field y#
Field xs#
Field ys#
Field moving
Function create:TBall()
Local b:TBall = New TBall
b.xs = 0
b.ys = 7
b.x = 380
b.y = 400
b.moving = False
Return b
EndFunction
Method u()
If moving Then
x:+xs
y:+ys
If x < 0 Or x > 780 Then xs = -xs
If y < 0 Then ys = -ys
EndIf
If KeyHit(KEY_RETURN) Then moving = True
EndMethod
Method d()
DrawOval x,y,20,20
If Not moving Then DrawText "Press ENTER to start",320,450
EndMethod
EndType
Type TBrick
Global list:TList = New TList
Field x,y,r,g,b
Field hit:Byte
Field angle#
Field alpha#
Field rotSpeed#
Function create:TBrick(x,y)
Local b:TBrick = New TBrick
b.x = x
b.y = y
b.r = Rand(90,120)
b.g = Rand(160,190)
b.b = 255
b.alpha = 1
b.rotSpeed = 1
Return b
EndFunction
Method u()
d()
If hit Then
angle:+rotSpeed
rotSpeed:*1.1
alpha:-0.02
If alpha <= 0 Then TBrick.list.remove(Self)
EndIf
EndMethod
Method d()
SetRotation angle
SA alpha
SC r,g,b
If hit Then
MidHandleImage imgBrick
Else
SetImageHandle imgBrick,0,0
EndIf
DrawImage imgBrick,x,y
EndMethod
EndType