.start
diff = Input("Difficulty(1-5):")
	If (diff<1) Or (diff>5) Then Goto start

Graphics3D 800,600,0,1
SetBuffer BackBuffer()

SeedRnd MilliSecs()

cam = CreateCamera()
PositionEntity cam, 0, 30, -50
CameraClsColor cam,32,64,128

light = CreateLight(0,cam)
	RotateEntity light, 45, 0, 0
	
oPl = CreateSphere(8)
ScaleMesh oPl, 15, 1, 1
EntityColor oPl,192,32,64
wPl	= MeshWidth(oPl)

lvl = diff
Global lifes = (6-diff)
Global punkte = 0


Dim tex(6)
tex(0)=CreateZahl("Press Space")
tex(1)=CreateZahl("GAME OVER")
tex(2)=CreateZahl("PAUSE")
tex(3)=CreateZahl("MULTIBALL")
tex(4)=CreateZahl("+10")
tex(5)=CreateZahl("+100")
tex(6)=CreateZahl("+1000")


CreateBlock(lvl)
CreateKug(0,2, 0,.5)
Gosub startup

FlushKeys()

sTime = MilliSecs()

Repeat
	
	;Status______________________
		xPl# = EntityX(oPl)
	;____________________________
	
	
	;Pause_______________________
		If KeyHit(25) Then
			CreateText(2, 0, 30)
			Gosub pause
		EndIf
	;____________________________			
	
	
	;Move_Player_________________
		If KeyDown(203) And (xPl > -40) Then
			MoveEntity oPl, -2.0/diff, 0, 0
		ElseIf KeyDown(205) And (xPl < 40) Then
			MoveEntity oPl, 2.0/diff, 0, 0
		EndIf
	;____________________________
	
	
	;Move_Cam____________________
		If KeyDown(200) Then
			TurnEntity cam, 1, 0, 0
		ElseIf KeyDown(208)
			TurnEntity cam, -1, 0, 0
		EndIf
	;____________________________
	
	;Status______________________
		
		bloxx = CountBlocks()
		If (bloxx = 0) Then 
			DelKug()
			If (lvl<10) Then
				lvl=lvl+1
				CreateBlock(lvl)
				CreateKug(xPl,2,0,.5)
				Gosub startup
			EndIf
		EndIf
		
		If (lifes=0) Then en=1
		
		time = (MilliSecs()-sTime)/1000
	;____________________________
	
	
	;Update_Game_________________
		UpdateKug(xPl, wPl)
		Collision()
		UpdateText()
	;____________________________

	RenderWorld
	
	;Debug_______________________
		
		Text 30, (600-30), "time", 1, 1
		Text 30, (600-15), time, 1, 1
		
		Text 200, (600-30), "Bloxx", 1, 1
		Text 200, (600-15), CountBlocks(), 1, 1
		
		Text 370, (600-30), "Balls", 1, 1
		Text 370, (600-15), CountKug(), 1, 1
		
		Text 540, (600-30), "Lifes", 1, 1
		Text 540, (600-15), lifes,1, 1
		
		Text 710, (600-30), "Points", 1, 1
		Text 710, (600-15), punkte, 1, 1
	;____________________________
	
	Flip
	Cls
Until en Or KeyHit(1)

CreateText(1, 0, 30)

Repeat
	
	UpdateText()
	RenderWorld
	Flip
	Cls
Until CountText()=0

Locate 300, 285:Print "Dein Score: " + punkte
Delay 2000

End

;Types____________________________________________
Type tBlock
	Field obj
	Field px%, py%
	Field sp
End Type

Type tKug
	Field obj
	Field px#, py#
	Field w%
	Field sp#
	Field del
End Type

Type tText
	Field obj
	Field scale#
	Field alpha#
End Type
;_________________________________________________

;FUNCTIONS________________________________________

Function CreateBlock(lvl)

	For y=0 To (lvl*2)
		For x = 0 To 13
			
			b.tBlock = New tBlock
				b\obj = CreateCube()
				b\px = -46 + x*7
				b\py = 65 - y*3
				b\sp = Rand(10)
				
				PositionEntity b\obj, b\px, b\py, 0
				ScaleEntity b\obj, 3, 1, .25				
				EntityColor b\obj, Rand(192,255),Rand(128,255),Rand(32,128)
		Next
	Next
End Function


Function CountBlocks()
	For b.tBlock = Each tBlock
		index = index + 1
	Next
	Return index
End Function


Function CreateKug(x#, y#, w%=0, sp#=0)
	
	k.tKug = New tKug
		k\obj = CreateSphere(8)
		k\px = x
		k\py = y
		If (w=0) Then
			k\w = Rand(-45, 45)
		Else
			k\w = w
		EndIf
		If (sp=0)
			k\sp = Rnd(.25,.75)
		Else
			k\sp = sp
		EndIf
		
		PositionEntity k\obj, k\px, k\py, 0
End Function

Function UpdateKug(xPl#, wPl#)
	
	For k.tKug = Each tKug
		
		k\px = k\px + Sin(k\w) * k\sp
		k\py = k\py + Cos(k\w) * k\sp
		
		PositionEntity k\obj, k\px, k\py, 0
		
		;Kollision
			
			If (k\py < -2) Then
				k\del=1
				If (lifes >= 0) And (CountKug()=1) Then
					lifes = lifes - 1
					CreateKug(0, 2)
				EndIf
			ElseIf (k\py >= 68) Then
				k\w = (180+(360-k\w)) Mod 360 
			ElseIf (k\py < 1) And (k\py > 0) Then
				If ((k\px > (xPl-wPl/2)) And (k\px < (xPl+wPl/2))) Then
					dist# = k\px-xPl
					k\w = (dist*4) Mod 360
				EndIf
			EndIf
			
			If (k\px <= -50)Or(k\px >= 50) Then
				k\w = ((360-k\w)) Mod 360
			EndIf
			
			If (k\w < 0) Then k\w = 360-Abs(k\w)
			
			If k\del Then
				FreeEntity k\obj
				Delete k.tKug
			EndIf
			
	Next
End Function


Function CountKug()
	For k.tKug = Each tKug
		index = index + 1
	Next
	Return index
End Function


Function DelKug()
	For k.tKug = Each tKug
		FreeEntity k\obj
		Delete k.tKug
	Next
End Function


Function Collision()
	
	For k.tKug = Each tKug
	For b.tBlock = Each tBlock
		
		dist# = EntityDistance(k\obj, b\obj)
		
		If (dist < 3) Then
			k\w = (180+(360-k\w))Mod 360
			Select b\sp
				Case 1:CreateKug(k\px, k\py, Rand(120,240)):CreateText(3, b\px, b\py)
				Case 2,3,4,5,6,7: punkte = punkte +10:CreateText(4, b\px, b\py)
				Case 8,9: punkte = punkte +100:CreateText(5, b\px, b\py)
				Case 10: punkte = punkte +1000:CreateText(6, b\px, b\py)
			End Select
				
			FreeEntity b\obj
			Delete b.tBlock
		EndIf
	Next
	Next
End Function


Function CreateZahl(txt$)
	font = LoadFont("blitz", 20, 0, 0, 0)
	SetFont font
	
	img = CreateImage(512, 512)
	ttex = CreateTexture(512,512)
		SetBuffer ImageBuffer(img)
			Cls
			Text 255, 255, txt, 1, 1
		SetBuffer BackBuffer()
		
	CopyRect 0, 0, 512, 512, 0, 0, ImageBuffer(img), TextureBuffer(ttex)
		
	Return ttex
End Function


Function CreateText(tt, x#, y#)
	
	t.tText = New tText
		t\obj = CreateSprite()
		If (tt= 4 Or 5) Then
			t\scale = 45
		Else
			t\scale = 15
		EndIf
		t\alpha = 1
		
		PositionEntity t\obj, x, y, 0
		ScaleSprite t\obj, t\scale, t\scale
		
		EntityColor t\obj, 255, 0, 255
		EntityBlend t\obj, 3
		EntityOrder t\obj, -10
		
		EntityTexture t\obj, tex(tt)
		
				
End Function


Function UpdateText()
	
	For t.tText = Each tText
		
		t\scale = t\scale * 1.05
		t\alpha = t\alpha-0.025
		ScaleSprite t\obj, t\scale, t\scale
		EntityAlpha t\obj, t\alpha
		
		If t\scale > 200 Then
			FreeEntity t\obj
			Delete t.tText
		EndIf
	Next	
End Function


Function CountText()
	For t.tText = Each tText
		index = index + 1
	Next
	Return index
End Function
;_________________________________________________


;SUBS_____________________________________________
.startup
CreateText(0, 0,30)
Repeat
	If KeyHit(1) Then End
	RenderWorld
	Flip
	Cls
Until KeyHit(57)
Return

.pause
FlushKeys()
Repeat
	
	RenderWorld
	Flip
	Cls
Until GetKey()
Return